# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['NetworkArgs', 'Network']

@pulumi.input_type
class NetworkArgs:
    def __init__(__self__, *,
                 name_label: pulumi.Input[str],
                 pool_id: pulumi.Input[str],
                 automatic: Optional[pulumi.Input[bool]] = None,
                 default_is_locked: Optional[pulumi.Input[bool]] = None,
                 mtu: Optional[pulumi.Input[int]] = None,
                 name_description: Optional[pulumi.Input[str]] = None,
                 nbd: Optional[pulumi.Input[bool]] = None,
                 source_pif_device: Optional[pulumi.Input[str]] = None,
                 vlan: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a Network resource.
        :param pulumi.Input[str] name_label: The name label of the network.
        :param pulumi.Input[str] pool_id: The pool id that this network should belong to.
        :param pulumi.Input[bool] default_is_locked: This argument controls whether the network should enforce VIF locking. This defaults to `false` which means that no filtering rules are applied.
        :param pulumi.Input[int] mtu: The MTU of the network. Defaults to `1500` if unspecified.
        :param pulumi.Input[bool] nbd: Whether the network should use a network block device. Defaults to `false` if unspecified.
        :param pulumi.Input[str] source_pif_device: The PIF device (eth0, eth1, etc) that will be used as an input during network creation. This parameter is required if a vlan is specified.
        :param pulumi.Input[int] vlan: The vlan to use for the network. Defaults to `0` meaning no VLAN.
        """
        pulumi.set(__self__, "name_label", name_label)
        pulumi.set(__self__, "pool_id", pool_id)
        if automatic is not None:
            pulumi.set(__self__, "automatic", automatic)
        if default_is_locked is not None:
            pulumi.set(__self__, "default_is_locked", default_is_locked)
        if mtu is not None:
            pulumi.set(__self__, "mtu", mtu)
        if name_description is not None:
            pulumi.set(__self__, "name_description", name_description)
        if nbd is not None:
            pulumi.set(__self__, "nbd", nbd)
        if source_pif_device is not None:
            pulumi.set(__self__, "source_pif_device", source_pif_device)
        if vlan is not None:
            pulumi.set(__self__, "vlan", vlan)

    @property
    @pulumi.getter(name="nameLabel")
    def name_label(self) -> pulumi.Input[str]:
        """
        The name label of the network.
        """
        return pulumi.get(self, "name_label")

    @name_label.setter
    def name_label(self, value: pulumi.Input[str]):
        pulumi.set(self, "name_label", value)

    @property
    @pulumi.getter(name="poolId")
    def pool_id(self) -> pulumi.Input[str]:
        """
        The pool id that this network should belong to.
        """
        return pulumi.get(self, "pool_id")

    @pool_id.setter
    def pool_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "pool_id", value)

    @property
    @pulumi.getter
    def automatic(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "automatic")

    @automatic.setter
    def automatic(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "automatic", value)

    @property
    @pulumi.getter(name="defaultIsLocked")
    def default_is_locked(self) -> Optional[pulumi.Input[bool]]:
        """
        This argument controls whether the network should enforce VIF locking. This defaults to `false` which means that no filtering rules are applied.
        """
        return pulumi.get(self, "default_is_locked")

    @default_is_locked.setter
    def default_is_locked(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "default_is_locked", value)

    @property
    @pulumi.getter
    def mtu(self) -> Optional[pulumi.Input[int]]:
        """
        The MTU of the network. Defaults to `1500` if unspecified.
        """
        return pulumi.get(self, "mtu")

    @mtu.setter
    def mtu(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "mtu", value)

    @property
    @pulumi.getter(name="nameDescription")
    def name_description(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "name_description")

    @name_description.setter
    def name_description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name_description", value)

    @property
    @pulumi.getter
    def nbd(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the network should use a network block device. Defaults to `false` if unspecified.
        """
        return pulumi.get(self, "nbd")

    @nbd.setter
    def nbd(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "nbd", value)

    @property
    @pulumi.getter(name="sourcePifDevice")
    def source_pif_device(self) -> Optional[pulumi.Input[str]]:
        """
        The PIF device (eth0, eth1, etc) that will be used as an input during network creation. This parameter is required if a vlan is specified.
        """
        return pulumi.get(self, "source_pif_device")

    @source_pif_device.setter
    def source_pif_device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "source_pif_device", value)

    @property
    @pulumi.getter
    def vlan(self) -> Optional[pulumi.Input[int]]:
        """
        The vlan to use for the network. Defaults to `0` meaning no VLAN.
        """
        return pulumi.get(self, "vlan")

    @vlan.setter
    def vlan(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "vlan", value)


@pulumi.input_type
class _NetworkState:
    def __init__(__self__, *,
                 automatic: Optional[pulumi.Input[bool]] = None,
                 default_is_locked: Optional[pulumi.Input[bool]] = None,
                 mtu: Optional[pulumi.Input[int]] = None,
                 name_description: Optional[pulumi.Input[str]] = None,
                 name_label: Optional[pulumi.Input[str]] = None,
                 nbd: Optional[pulumi.Input[bool]] = None,
                 pool_id: Optional[pulumi.Input[str]] = None,
                 source_pif_device: Optional[pulumi.Input[str]] = None,
                 vlan: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering Network resources.
        :param pulumi.Input[bool] default_is_locked: This argument controls whether the network should enforce VIF locking. This defaults to `false` which means that no filtering rules are applied.
        :param pulumi.Input[int] mtu: The MTU of the network. Defaults to `1500` if unspecified.
        :param pulumi.Input[str] name_label: The name label of the network.
        :param pulumi.Input[bool] nbd: Whether the network should use a network block device. Defaults to `false` if unspecified.
        :param pulumi.Input[str] pool_id: The pool id that this network should belong to.
        :param pulumi.Input[str] source_pif_device: The PIF device (eth0, eth1, etc) that will be used as an input during network creation. This parameter is required if a vlan is specified.
        :param pulumi.Input[int] vlan: The vlan to use for the network. Defaults to `0` meaning no VLAN.
        """
        if automatic is not None:
            pulumi.set(__self__, "automatic", automatic)
        if default_is_locked is not None:
            pulumi.set(__self__, "default_is_locked", default_is_locked)
        if mtu is not None:
            pulumi.set(__self__, "mtu", mtu)
        if name_description is not None:
            pulumi.set(__self__, "name_description", name_description)
        if name_label is not None:
            pulumi.set(__self__, "name_label", name_label)
        if nbd is not None:
            pulumi.set(__self__, "nbd", nbd)
        if pool_id is not None:
            pulumi.set(__self__, "pool_id", pool_id)
        if source_pif_device is not None:
            pulumi.set(__self__, "source_pif_device", source_pif_device)
        if vlan is not None:
            pulumi.set(__self__, "vlan", vlan)

    @property
    @pulumi.getter
    def automatic(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "automatic")

    @automatic.setter
    def automatic(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "automatic", value)

    @property
    @pulumi.getter(name="defaultIsLocked")
    def default_is_locked(self) -> Optional[pulumi.Input[bool]]:
        """
        This argument controls whether the network should enforce VIF locking. This defaults to `false` which means that no filtering rules are applied.
        """
        return pulumi.get(self, "default_is_locked")

    @default_is_locked.setter
    def default_is_locked(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "default_is_locked", value)

    @property
    @pulumi.getter
    def mtu(self) -> Optional[pulumi.Input[int]]:
        """
        The MTU of the network. Defaults to `1500` if unspecified.
        """
        return pulumi.get(self, "mtu")

    @mtu.setter
    def mtu(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "mtu", value)

    @property
    @pulumi.getter(name="nameDescription")
    def name_description(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "name_description")

    @name_description.setter
    def name_description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name_description", value)

    @property
    @pulumi.getter(name="nameLabel")
    def name_label(self) -> Optional[pulumi.Input[str]]:
        """
        The name label of the network.
        """
        return pulumi.get(self, "name_label")

    @name_label.setter
    def name_label(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name_label", value)

    @property
    @pulumi.getter
    def nbd(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the network should use a network block device. Defaults to `false` if unspecified.
        """
        return pulumi.get(self, "nbd")

    @nbd.setter
    def nbd(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "nbd", value)

    @property
    @pulumi.getter(name="poolId")
    def pool_id(self) -> Optional[pulumi.Input[str]]:
        """
        The pool id that this network should belong to.
        """
        return pulumi.get(self, "pool_id")

    @pool_id.setter
    def pool_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "pool_id", value)

    @property
    @pulumi.getter(name="sourcePifDevice")
    def source_pif_device(self) -> Optional[pulumi.Input[str]]:
        """
        The PIF device (eth0, eth1, etc) that will be used as an input during network creation. This parameter is required if a vlan is specified.
        """
        return pulumi.get(self, "source_pif_device")

    @source_pif_device.setter
    def source_pif_device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "source_pif_device", value)

    @property
    @pulumi.getter
    def vlan(self) -> Optional[pulumi.Input[int]]:
        """
        The vlan to use for the network. Defaults to `0` meaning no VLAN.
        """
        return pulumi.get(self, "vlan")

    @vlan.setter
    def vlan(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "vlan", value)


warnings.warn("""xenorchestra.index/network.Network has been deprecated in favor of xenorchestra.index/xoanetwork.XoaNetwork""", DeprecationWarning)


class Network(pulumi.CustomResource):
    warnings.warn("""xenorchestra.index/network.Network has been deprecated in favor of xenorchestra.index/xoanetwork.XoaNetwork""", DeprecationWarning)

    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 automatic: Optional[pulumi.Input[bool]] = None,
                 default_is_locked: Optional[pulumi.Input[bool]] = None,
                 mtu: Optional[pulumi.Input[int]] = None,
                 name_description: Optional[pulumi.Input[str]] = None,
                 name_label: Optional[pulumi.Input[str]] = None,
                 nbd: Optional[pulumi.Input[bool]] = None,
                 pool_id: Optional[pulumi.Input[str]] = None,
                 source_pif_device: Optional[pulumi.Input[str]] = None,
                 vlan: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        ## Example Usage

        ```python
        import pulumi
        import pulumi_xenorchestra as xenorchestra

        host1 = xenorchestra.get_xoa_host(name_label="Your host")
        # Create a single server network private network
        private_network = xenorchestra.XoaNetwork("private_network",
            name_label="new network name",
            pool_id=host1.pool_id)
        # Create a network with a 22 VLAN tag from the eth0 device
        vlan_network = xenorchestra.XoaNetwork("vlan_network",
            name_label="new network name",
            pool_id=host1.pool_id,
            source_pif_device="eth0",
            vlan=22)
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] default_is_locked: This argument controls whether the network should enforce VIF locking. This defaults to `false` which means that no filtering rules are applied.
        :param pulumi.Input[int] mtu: The MTU of the network. Defaults to `1500` if unspecified.
        :param pulumi.Input[str] name_label: The name label of the network.
        :param pulumi.Input[bool] nbd: Whether the network should use a network block device. Defaults to `false` if unspecified.
        :param pulumi.Input[str] pool_id: The pool id that this network should belong to.
        :param pulumi.Input[str] source_pif_device: The PIF device (eth0, eth1, etc) that will be used as an input during network creation. This parameter is required if a vlan is specified.
        :param pulumi.Input[int] vlan: The vlan to use for the network. Defaults to `0` meaning no VLAN.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NetworkArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        ```python
        import pulumi
        import pulumi_xenorchestra as xenorchestra

        host1 = xenorchestra.get_xoa_host(name_label="Your host")
        # Create a single server network private network
        private_network = xenorchestra.XoaNetwork("private_network",
            name_label="new network name",
            pool_id=host1.pool_id)
        # Create a network with a 22 VLAN tag from the eth0 device
        vlan_network = xenorchestra.XoaNetwork("vlan_network",
            name_label="new network name",
            pool_id=host1.pool_id,
            source_pif_device="eth0",
            vlan=22)
        ```

        :param str resource_name: The name of the resource.
        :param NetworkArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NetworkArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 automatic: Optional[pulumi.Input[bool]] = None,
                 default_is_locked: Optional[pulumi.Input[bool]] = None,
                 mtu: Optional[pulumi.Input[int]] = None,
                 name_description: Optional[pulumi.Input[str]] = None,
                 name_label: Optional[pulumi.Input[str]] = None,
                 nbd: Optional[pulumi.Input[bool]] = None,
                 pool_id: Optional[pulumi.Input[str]] = None,
                 source_pif_device: Optional[pulumi.Input[str]] = None,
                 vlan: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        pulumi.log.warn("""Network is deprecated: xenorchestra.index/network.Network has been deprecated in favor of xenorchestra.index/xoanetwork.XoaNetwork""")
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NetworkArgs.__new__(NetworkArgs)

            __props__.__dict__["automatic"] = automatic
            __props__.__dict__["default_is_locked"] = default_is_locked
            __props__.__dict__["mtu"] = mtu
            __props__.__dict__["name_description"] = name_description
            if name_label is None and not opts.urn:
                raise TypeError("Missing required property 'name_label'")
            __props__.__dict__["name_label"] = name_label
            __props__.__dict__["nbd"] = nbd
            if pool_id is None and not opts.urn:
                raise TypeError("Missing required property 'pool_id'")
            __props__.__dict__["pool_id"] = pool_id
            __props__.__dict__["source_pif_device"] = source_pif_device
            __props__.__dict__["vlan"] = vlan
        super(Network, __self__).__init__(
            'xenorchestra:index/network:Network',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            automatic: Optional[pulumi.Input[bool]] = None,
            default_is_locked: Optional[pulumi.Input[bool]] = None,
            mtu: Optional[pulumi.Input[int]] = None,
            name_description: Optional[pulumi.Input[str]] = None,
            name_label: Optional[pulumi.Input[str]] = None,
            nbd: Optional[pulumi.Input[bool]] = None,
            pool_id: Optional[pulumi.Input[str]] = None,
            source_pif_device: Optional[pulumi.Input[str]] = None,
            vlan: Optional[pulumi.Input[int]] = None) -> 'Network':
        """
        Get an existing Network resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] default_is_locked: This argument controls whether the network should enforce VIF locking. This defaults to `false` which means that no filtering rules are applied.
        :param pulumi.Input[int] mtu: The MTU of the network. Defaults to `1500` if unspecified.
        :param pulumi.Input[str] name_label: The name label of the network.
        :param pulumi.Input[bool] nbd: Whether the network should use a network block device. Defaults to `false` if unspecified.
        :param pulumi.Input[str] pool_id: The pool id that this network should belong to.
        :param pulumi.Input[str] source_pif_device: The PIF device (eth0, eth1, etc) that will be used as an input during network creation. This parameter is required if a vlan is specified.
        :param pulumi.Input[int] vlan: The vlan to use for the network. Defaults to `0` meaning no VLAN.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _NetworkState.__new__(_NetworkState)

        __props__.__dict__["automatic"] = automatic
        __props__.__dict__["default_is_locked"] = default_is_locked
        __props__.__dict__["mtu"] = mtu
        __props__.__dict__["name_description"] = name_description
        __props__.__dict__["name_label"] = name_label
        __props__.__dict__["nbd"] = nbd
        __props__.__dict__["pool_id"] = pool_id
        __props__.__dict__["source_pif_device"] = source_pif_device
        __props__.__dict__["vlan"] = vlan
        return Network(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def automatic(self) -> pulumi.Output[Optional[bool]]:
        return pulumi.get(self, "automatic")

    @property
    @pulumi.getter(name="defaultIsLocked")
    def default_is_locked(self) -> pulumi.Output[Optional[bool]]:
        """
        This argument controls whether the network should enforce VIF locking. This defaults to `false` which means that no filtering rules are applied.
        """
        return pulumi.get(self, "default_is_locked")

    @property
    @pulumi.getter
    def mtu(self) -> pulumi.Output[Optional[int]]:
        """
        The MTU of the network. Defaults to `1500` if unspecified.
        """
        return pulumi.get(self, "mtu")

    @property
    @pulumi.getter(name="nameDescription")
    def name_description(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "name_description")

    @property
    @pulumi.getter(name="nameLabel")
    def name_label(self) -> pulumi.Output[str]:
        """
        The name label of the network.
        """
        return pulumi.get(self, "name_label")

    @property
    @pulumi.getter
    def nbd(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether the network should use a network block device. Defaults to `false` if unspecified.
        """
        return pulumi.get(self, "nbd")

    @property
    @pulumi.getter(name="poolId")
    def pool_id(self) -> pulumi.Output[str]:
        """
        The pool id that this network should belong to.
        """
        return pulumi.get(self, "pool_id")

    @property
    @pulumi.getter(name="sourcePifDevice")
    def source_pif_device(self) -> pulumi.Output[Optional[str]]:
        """
        The PIF device (eth0, eth1, etc) that will be used as an input during network creation. This parameter is required if a vlan is specified.
        """
        return pulumi.get(self, "source_pif_device")

    @property
    @pulumi.getter
    def vlan(self) -> pulumi.Output[Optional[int]]:
        """
        The vlan to use for the network. Defaults to `0` meaning no VLAN.
        """
        return pulumi.get(self, "vlan")

